Description: This a template to create a VPC/Subnet and IGW.
# Creates the following:
# - VPC
# - Internet Gateway
# - Internet Gateway Attachment to VPC
# - Public Subnet
# - Public Route Table, to create a route Table
# - Default Public Route to link Internet Gateway to Public Route
# - Link Public route to Public subnet, so that the Subnet can become public
# CLI Command example: aws cloudformation create-stack --stack-name stackwithparms --template-body file://createVPCSubnetIGW.ym

Parameters: # Variables that can be referred in the Resource Section
  EnvironmentName: # The Parameters cannot be a dynamic one like this !Join ['', [!Ref "AWS::StackName", "-VPC" ]] so, not using this parm to calculate the variable name
    Description: Some Name
    Type: String
    Default: None
  VpcCIDR:
    Description: VPC CIDR Block
    Type: String
    Default: 10.1.0.0/16

Resources:
  # CLI Command, windows: aws cloudformation create-stack --stack-name blabl<nameofStack> --template-body file://createEC2.yml --region eu-west-1
  # First, a VPC:
  VPC:
    Type: AWS::EC2::VPC
    Properties:
      CidrBlock: !Ref VpcCIDR
      EnableDnsSupport: true
      EnableDnsHostnames: true
      Tags:
      - Key: Name
        Value:  !Join ['', [!Ref "AWS::StackName", "-VPC" ]]
  InternetGateway: # Create an Interconnect
    Type: AWS::EC2::InternetGateway
    Properties:
      Tags:
        - Key: Name
          Value: !Join ['', [!Ref "AWS::StackName", "-IGW" ]]
  InternetGatewayAttachment: # Attach VPC to the Internet Gateway
    Type: AWS::EC2::VPCGatewayAttachment
    Properties:
      InternetGatewayId: !Ref InternetGateway
      VpcId: !Ref VPC
  PublicSubnet: # Create a Subnet, in futher steps below we will route Subnet to IGW to make the subnet public
    Type: AWS::EC2::Subnet
    Properties: 
      #AssignIpv6AddressOnCreation: false
      #AvailabilityZone: String
      CidrBlock: 10.1.0.0/16
      #Ipv6CidrBlock: String
      MapPublicIpOnLaunch: true
      #OutpostArn: String
      Tags: 
        - Key: Name
          Value:  !Join ['', [!Ref "AWS::StackName", "-PublicSubnet" ]]
      VpcId:
        Ref: VPC
  PublicRouteTable: #Create a new route table. As a best practice we should not use default AWS route tables
    Type: AWS::EC2::RouteTable
    Properties:
      VpcId: !Ref VPC
      Tags:
        - Key: Name
          Value: !Join ['', [!Ref "AWS::StackName", "-PublicRouteTable" ]]
  DefaultPublicRoute: # Add a route to IGW in the route table
    Type: AWS::EC2::Route
    DependsOn: InternetGatewayAttachment
    Properties:
      RouteTableId: !Ref PublicRouteTable
      DestinationCidrBlock: 0.0.0.0/0
      GatewayId: !Ref InternetGateway
  PublicSubnetRouteTableAssociation: # associate the route table to subnet. As route table was associated to IGW, this subnet is now Public
    Type: AWS::EC2::SubnetRouteTableAssociation
    Properties:
      RouteTableId: !Ref PublicRouteTable
      SubnetId: !Ref PublicSubnet